<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LASi: LASi::PostscriptDocument Class Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.4 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceLASi.html">LASi</a>::<a class="el" href="classLASi_1_1PostscriptDocument.html">PostscriptDocument</a></div>
<h1>LASi::PostscriptDocument Class Reference</h1><!-- doxytag: class="LASi::PostscriptDocument" -->Composes Postscript document as three separate and independant streams for header, body and footer.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="LASi_8h-source.html">LASi.h</a>&gt;</code>
<p>

<p>
<a href="classLASi_1_1PostscriptDocument-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#7cd59d0431965b0440c858200e260e94">PostscriptDocument</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#b41fb72dce1e1c5e3e8655dd7694cea7">~PostscriptDocument</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#3b78a2ccc98eb3a8d71e8dc96d76886a">setFont</a> (const char *const family=&quot;sans&quot;, LASi::FontStyle=LASi::NORMAL_STYLE, <a class="el" href="namespaceLASi.html#cad6af5e11af48ac0820470cb91b11cc">LASi::FontWeight</a>=LASi::NORMAL_WEIGHT, <a class="el" href="namespaceLASi.html#0c4dd4681ddefc547e182e0a91ffa33c">LASi::FontVariant</a>=LASi::NORMAL_VARIANT, <a class="el" href="namespaceLASi.html#1078bb628a6b0474a6e0e5e75acad837">LASi::FontStretch</a>=LASi::NORMAL_STRETCH)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the font that all subsequent text written to bodyStream() or footerStream() will be rendered with.  <a href="#3b78a2ccc98eb3a8d71e8dc96d76886a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#2de93d93c4979c187db13fd64de85844">setFontSize</a> (const double size)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the font size, in points, that all subsequent text written to bodyStream() or footerStream() will be rendered with.  <a href="#2de93d93c4979c187db13fd64de85844"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::ostringstream &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#999bf5a5d71339e3acdc1889e9bc68e3">osHeader</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns stream for Postscript header.  <a href="#999bf5a5d71339e3acdc1889e9bc68e3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#fe7e58d323555a8be0b1cb8ed94e373d">osBody</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns stream for Postscript body.  <a href="#fe7e58d323555a8be0b1cb8ed94e373d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#9331d7b137d0fd6f1107e88b18851970">osFooter</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns stream for Postscript footer.  <a href="#9331d7b137d0fd6f1107e88b18851970"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#b47de85111ee981959f363f757b88f9a">write</a> (std::ostream &amp;os, double llx=0, double lly=0, double urx=0, double ury=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Closes all streams and writes completed Postscript document to os.  <a href="#b47de85111ee981959f363f757b88f9a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#ca02cc38e3fdcfdb8c001e6cd67de6da">get_dimensions</a> (const char *s, double *lineSpacing, double *xAdvance=NULL, double *yMin=NULL, double *yMax=NULL)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return string dimensions: lineSpacing: inter-line spacing xAdvance: width of the string yMin: y-coordinate bounding the lowest descender, Indic under-consonantal vowel, etc.  <a href="#ca02cc38e3fdcfdb8c001e6cd67de6da"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#6f78aac9ab5db21826dd3fa83b044325">get_dimensions</a> (std::string s, double *lineSpacing, double *xAdvance=NULL, double *yMin=NULL, double *yMax=NULL)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the line spacing, x-advance, y-minimum and y-maximum based on the current font face and font size.  <a href="#6f78aac9ab5db21826dd3fa83b044325"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map&lt; <a class="el" href="classLASi_1_1PostscriptDocument_1_1GlyphId.html">GlyphId</a>,<br>
 <a class="el" href="classFreetypeGlyphMgr.html">FreetypeGlyphMgr</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#d04760970ff8a69b4cc0df3dc3787a50">GlyphMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Maps glyph routine name to FT_Glyph instance.  <a href="#d04760970ff8a69b4cc0df3dc3787a50"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef void(PostscriptDocument::*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#b3421a1f3572c75df7218a3c35f2b108">GLYPH_FUNC</a> )(const GlyphMap::value_type &amp;, void *contextData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pointer to a function that takes a reference to a glyph and to x and y coordinates.  <a href="#b3421a1f3572c75df7218a3c35f2b108"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#02f8faf65c76d41011cffa08c7ace44e">invoke_glyph_routine</a> (const GlyphMap::value_type &amp;, void *contextData)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#fc2524a5b7e7b0c85f17984975748172">accrue_dimensions</a> (const GlyphMap::value_type &amp;, void *contextData1)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#d6761365a3b9a106e62c0c498a9ce06a">for_each_glyph_do</a> (const std::string &amp;, const <a class="el" href="classLASi_1_1PostscriptDocument.html#b3421a1f3572c75df7218a3c35f2b108">GLYPH_FUNC</a>, void *contextData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Decomposes string into glyphs and applies GLYPH_FUNC to each glyph.  <a href="#d6761365a3b9a106e62c0c498a9ce06a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">PangoContext *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#fd925cef338df4ae4a0c3d4a8247beef">pangoContext</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#ae3eaec64d39b063f61fe4d1405c2457">glyphProcName</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><dl class="return" compact><dt><b>Returns:</b></dt><dd>name of Postscript glyph routine </dd></dl>
 <a href="#ae3eaec64d39b063f61fe4d1405c2457"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#12c5c90259b16d8778219706a9ce121a">getFontSize</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><dl class="return" compact><dt><b>Returns:</b></dt><dd>font size in points (1/72 in. </dd></dl>
 <a href="#12c5c90259b16d8778219706a9ce121a"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classLASi_1_1PostscriptDocument.html#d04760970ff8a69b4cc0df3dc3787a50">GlyphMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#891b253b04c2bb4552b3b981d3a4ac5e">_glyphMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classContextMgr.html">ContextMgr</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#e0b414aa7ba77d738b8c8dc3c1a6221e">_pContextMgr</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#0599d87cb9a22fc1a8698791fcb1691c">_fontSize</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::ostringstream&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#3d96e4d1443485432b973606c7ab98c5">_osHeader</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#57476e581450042bad24eb536e72bf11">_osBody</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#9c160fc430c5855a953ebba33ed67b49">_osFooter</a></td></tr>

<tr><td colspan="2"><br><h2>Static Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#7db60f9499f34edaa1fff5dbcfa1bdc5">DRAWING_SCALE</a> = PANGO_SCALE</td></tr>

<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#43742b164a1653e57d93ffbbf4df70de">write_glyph_routine_to_stream</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument.html#7fc469992ea83eaa8e008fe32eb4828f">show</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument_1_1GlyphId.html">GlyphId</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">For internal use only.  <a href="classLASi_1_1PostscriptDocument_1_1GlyphId.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLASi_1_1PostscriptDocument_1_1write__glyph__routine__to__stream.html">write_glyph_routine_to_stream</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">For internal use only.  <a href="classLASi_1_1PostscriptDocument_1_1write__glyph__routine__to__stream.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Composes Postscript document as three separate and independant streams for header, body and footer. 
<p>
Body and footer streams respond to <a class="el" href="classLASi_1_1show.html" title="stream applicator applied to oPostscriptStream.">LASi::show</a> applicator which generates Postscript commands to display a string by using glyph routines instead of a Postscript font. <hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="d04760970ff8a69b4cc0df3dc3787a50"></a><!-- doxytag: member="LASi::PostscriptDocument::GlyphMap" ref="d04760970ff8a69b4cc0df3dc3787a50" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classLASi_1_1PostscriptDocument_1_1GlyphId.html">GlyphId</a>, <a class="el" href="classFreetypeGlyphMgr.html">FreetypeGlyphMgr</a>&gt; <a class="el" href="classLASi_1_1PostscriptDocument.html#d04760970ff8a69b4cc0df3dc3787a50">LASi::PostscriptDocument::GlyphMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Maps glyph routine name to FT_Glyph instance. 
<p>

</div>
</div><p>
<a class="anchor" name="b3421a1f3572c75df7218a3c35f2b108"></a><!-- doxytag: member="LASi::PostscriptDocument::GLYPH_FUNC" ref="b3421a1f3572c75df7218a3c35f2b108" args=")(const GlyphMap::value_type &amp;, void *contextData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(PostscriptDocument::* <a class="el" href="classLASi_1_1PostscriptDocument.html#b3421a1f3572c75df7218a3c35f2b108">LASi::PostscriptDocument::GLYPH_FUNC</a>)(const GlyphMap::value_type &amp;, void *contextData)<code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pointer to a function that takes a reference to a glyph and to x and y coordinates. 
<p>
May return new x and y coordinates. 
</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="7cd59d0431965b0440c858200e260e94"></a><!-- doxytag: member="LASi::PostscriptDocument::PostscriptDocument" ref="7cd59d0431965b0440c858200e260e94" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PostscriptDocument::PostscriptDocument           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="b41fb72dce1e1c5e3e8655dd7694cea7"></a><!-- doxytag: member="LASi::PostscriptDocument::~PostscriptDocument" ref="b41fb72dce1e1c5e3e8655dd7694cea7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PostscriptDocument::~PostscriptDocument           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="3b78a2ccc98eb3a8d71e8dc96d76886a"></a><!-- doxytag: member="LASi::PostscriptDocument::setFont" ref="3b78a2ccc98eb3a8d71e8dc96d76886a" args="(const char *const family=&quot;sans&quot;, LASi::FontStyle=LASi::NORMAL_STYLE, LASi::FontWeight=LASi::NORMAL_WEIGHT, LASi::FontVariant=LASi::NORMAL_VARIANT, LASi::FontStretch=LASi::NORMAL_STRETCH)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PostscriptDocument::setFont           </td>
          <td>(</td>
          <td class="paramtype">const char *const &nbsp;</td>
          <td class="paramname"> <em>family</em> = <code>&quot;sans&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceLASi.html#677a16ea4956907672f1eab92d955672">LASi::FontStyle</a>&nbsp;</td>
          <td class="paramname"> <em>style</em> = <code>LASi::NORMAL_STYLE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceLASi.html#cad6af5e11af48ac0820470cb91b11cc">LASi::FontWeight</a>&nbsp;</td>
          <td class="paramname"> <em>weight</em> = <code>LASi::NORMAL_WEIGHT</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceLASi.html#0c4dd4681ddefc547e182e0a91ffa33c">LASi::FontVariant</a>&nbsp;</td>
          <td class="paramname"> <em>variant</em> = <code>LASi::NORMAL_VARIANT</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceLASi.html#1078bb628a6b0474a6e0e5e75acad837">LASi::FontStretch</a>&nbsp;</td>
          <td class="paramname"> <em>stretch</em> = <code>LASi::NORMAL_STRETCH</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the font that all subsequent text written to bodyStream() or footerStream() will be rendered with. 
<p>

</div>
</div><p>
<a class="anchor" name="2de93d93c4979c187db13fd64de85844"></a><!-- doxytag: member="LASi::PostscriptDocument::setFontSize" ref="2de93d93c4979c187db13fd64de85844" args="(const double size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LASi::PostscriptDocument::setFontSize           </td>
          <td>(</td>
          <td class="paramtype">const double&nbsp;</td>
          <td class="paramname"> <em>size</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the font size, in points, that all subsequent text written to bodyStream() or footerStream() will be rendered with. 
<p>

</div>
</div><p>
<a class="anchor" name="999bf5a5d71339e3acdc1889e9bc68e3"></a><!-- doxytag: member="LASi::PostscriptDocument::osHeader" ref="999bf5a5d71339e3acdc1889e9bc68e3" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::ostringstream&amp; LASi::PostscriptDocument::osHeader           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns stream for Postscript header. 
<p>

</div>
</div><p>
<a class="anchor" name="fe7e58d323555a8be0b1cb8ed94e373d"></a><!-- doxytag: member="LASi::PostscriptDocument::osBody" ref="fe7e58d323555a8be0b1cb8ed94e373d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a>&amp; LASi::PostscriptDocument::osBody           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns stream for Postscript body. 
<p>

</div>
</div><p>
<a class="anchor" name="9331d7b137d0fd6f1107e88b18851970"></a><!-- doxytag: member="LASi::PostscriptDocument::osFooter" ref="9331d7b137d0fd6f1107e88b18851970" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a>&amp; LASi::PostscriptDocument::osFooter           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns stream for Postscript footer. 
<p>

</div>
</div><p>
<a class="anchor" name="b47de85111ee981959f363f757b88f9a"></a><!-- doxytag: member="LASi::PostscriptDocument::write" ref="b47de85111ee981959f363f757b88f9a" args="(std::ostream &amp;os, double llx=0, double lly=0, double urx=0, double ury=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PostscriptDocument::write           </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&nbsp;</td>
          <td class="paramname"> <em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>llx</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>lly</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>urx</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&nbsp;</td>
          <td class="paramname"> <em>ury</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Closes all streams and writes completed Postscript document to os. 
<p>
Writes out the document.<p>
Header will include glyph routines for all text glyphs in body and footer.<p>
2006.05.01.ET Addendum: To create an EPS document, just include the the four BoundingBox coordinates llx, lly, urx, ury (dimensions in points). These are optional parameters -- When not included, you'll get a regular PS document. When included, you'll get an EPS document. 
</div>
</div><p>
<a class="anchor" name="ca02cc38e3fdcfdb8c001e6cd67de6da"></a><!-- doxytag: member="LASi::PostscriptDocument::get_dimensions" ref="ca02cc38e3fdcfdb8c001e6cd67de6da" args="(const char *s, double *lineSpacing, double *xAdvance=NULL, double *yMin=NULL, double *yMax=NULL)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PostscriptDocument::get_dimensions           </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>lineSpacing</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>xAdvance</em> = <code>NULL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>yMin</em> = <code>NULL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>yMax</em> = <code>NULL</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Return string dimensions: lineSpacing: inter-line spacing xAdvance: width of the string yMin: y-coordinate bounding the lowest descender, Indic under-consonantal vowel, etc. 
<p>
Returns the line spacing, x-advance, y-minimum and y-maximum based on the current font face and font size.<p>
yMax: y-coordinate bounding the highest ascender, diacritic, Indic over-letter vowel, etc.<p>
A bounding box around the text string, s, can be constructed from the xAdvance, yMinimum, and yMaximum. yMinimum tells you the descent from the baseline. yMaximum tells you the ascent from the baseline. The line spacing provides an inter-line spacing for multi-line text layout.<p>
This version accepts a const C-style character string. 
</div>
</div><p>
<a class="anchor" name="6f78aac9ab5db21826dd3fa83b044325"></a><!-- doxytag: member="LASi::PostscriptDocument::get_dimensions" ref="6f78aac9ab5db21826dd3fa83b044325" args="(std::string s, double *lineSpacing, double *xAdvance=NULL, double *yMin=NULL, double *yMax=NULL)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PostscriptDocument::get_dimensions           </td>
          <td>(</td>
          <td class="paramtype">std::string&nbsp;</td>
          <td class="paramname"> <em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>lineSpacing</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>xAdvance</em> = <code>NULL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>yMin</em> = <code>NULL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&nbsp;</td>
          <td class="paramname"> <em>yMax</em> = <code>NULL</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the line spacing, x-advance, y-minimum and y-maximum based on the current font face and font size. 
<p>
A bounding box around the text string, s, can be constructed from the xAdvance, yMinimum, and yMaximum. yMinimum tells you the descent from the baseline. yMaximum tells you the ascent from the baseline. The line spacing provides an inter-line spacing for multi-line text layout.<p>
This version accepts an STL standard string class string. 
</div>
</div><p>
<a class="anchor" name="02f8faf65c76d41011cffa08c7ace44e"></a><!-- doxytag: member="LASi::PostscriptDocument::invoke_glyph_routine" ref="02f8faf65c76d41011cffa08c7ace44e" args="(const GlyphMap::value_type &amp;, void *contextData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LASi::PostscriptDocument::invoke_glyph_routine           </td>
          <td>(</td>
          <td class="paramtype">const GlyphMap::value_type &amp;&nbsp;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>contextData</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="fc2524a5b7e7b0c85f17984975748172"></a><!-- doxytag: member="LASi::PostscriptDocument::accrue_dimensions" ref="fc2524a5b7e7b0c85f17984975748172" args="(const GlyphMap::value_type &amp;, void *contextData1)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LASi::PostscriptDocument::accrue_dimensions           </td>
          <td>(</td>
          <td class="paramtype">const GlyphMap::value_type &amp;&nbsp;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>contextData1</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="d6761365a3b9a106e62c0c498a9ce06a"></a><!-- doxytag: member="LASi::PostscriptDocument::for_each_glyph_do" ref="d6761365a3b9a106e62c0c498a9ce06a" args="(const std::string &amp;, const GLYPH_FUNC, void *contextData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LASi::PostscriptDocument::for_each_glyph_do           </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&nbsp;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const &nbsp;</td>
          <td class="paramname"> <em>GLYPH_FUNC</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>contextData</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Decomposes string into glyphs and applies GLYPH_FUNC to each glyph. 
<p>

</div>
</div><p>
<a class="anchor" name="fd925cef338df4ae4a0c3d4a8247beef"></a><!-- doxytag: member="LASi::PostscriptDocument::pangoContext" ref="fd925cef338df4ae4a0c3d4a8247beef" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PangoContext * PostscriptDocument::pangoContext           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inline, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="ae3eaec64d39b063f61fe4d1405c2457"></a><!-- doxytag: member="LASi::PostscriptDocument::glyphProcName" ref="ae3eaec64d39b063f61fe4d1405c2457" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string LASi::PostscriptDocument::glyphProcName           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>name of Postscript glyph routine </dd></dl>

<p>

</div>
</div><p>
<a class="anchor" name="12c5c90259b16d8778219706a9ce121a"></a><!-- doxytag: member="LASi::PostscriptDocument::getFontSize" ref="12c5c90259b16d8778219706a9ce121a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double LASi::PostscriptDocument::getFontSize           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inline, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>font size in points (1/72 in. </dd></dl>

<p>
) 
</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="43742b164a1653e57d93ffbbf4df70de"></a><!-- doxytag: member="LASi::PostscriptDocument::write_glyph_routine_to_stream" ref="43742b164a1653e57d93ffbbf4df70de" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classLASi_1_1PostscriptDocument_1_1write__glyph__routine__to__stream.html">write_glyph_routine_to_stream</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="7fc469992ea83eaa8e008fe32eb4828f"></a><!-- doxytag: member="LASi::PostscriptDocument::show" ref="7fc469992ea83eaa8e008fe32eb4828f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classLASi_1_1show.html">show</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="891b253b04c2bb4552b3b981d3a4ac5e"></a><!-- doxytag: member="LASi::PostscriptDocument::_glyphMap" ref="891b253b04c2bb4552b3b981d3a4ac5e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classLASi_1_1PostscriptDocument.html#d04760970ff8a69b4cc0df3dc3787a50">GlyphMap</a> <a class="el" href="classLASi_1_1PostscriptDocument.html#891b253b04c2bb4552b3b981d3a4ac5e">LASi::PostscriptDocument::_glyphMap</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="7db60f9499f34edaa1fff5dbcfa1bdc5"></a><!-- doxytag: member="LASi::PostscriptDocument::DRAWING_SCALE" ref="7db60f9499f34edaa1fff5dbcfa1bdc5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="classLASi_1_1PostscriptDocument.html#7db60f9499f34edaa1fff5dbcfa1bdc5">PostscriptDocument::DRAWING_SCALE</a> = PANGO_SCALE<code> [static, private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="e0b414aa7ba77d738b8c8dc3c1a6221e"></a><!-- doxytag: member="LASi::PostscriptDocument::_pContextMgr" ref="e0b414aa7ba77d738b8c8dc3c1a6221e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classContextMgr.html">ContextMgr</a>* <a class="el" href="classLASi_1_1PostscriptDocument.html#e0b414aa7ba77d738b8c8dc3c1a6221e">LASi::PostscriptDocument::_pContextMgr</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="0599d87cb9a22fc1a8698791fcb1691c"></a><!-- doxytag: member="LASi::PostscriptDocument::_fontSize" ref="0599d87cb9a22fc1a8698791fcb1691c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double <a class="el" href="classLASi_1_1PostscriptDocument.html#0599d87cb9a22fc1a8698791fcb1691c">LASi::PostscriptDocument::_fontSize</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="3d96e4d1443485432b973606c7ab98c5"></a><!-- doxytag: member="LASi::PostscriptDocument::_osHeader" ref="3d96e4d1443485432b973606c7ab98c5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::ostringstream <a class="el" href="classLASi_1_1PostscriptDocument.html#3d96e4d1443485432b973606c7ab98c5">LASi::PostscriptDocument::_osHeader</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="57476e581450042bad24eb536e72bf11"></a><!-- doxytag: member="LASi::PostscriptDocument::_osBody" ref="57476e581450042bad24eb536e72bf11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a> <a class="el" href="classLASi_1_1PostscriptDocument.html#57476e581450042bad24eb536e72bf11">LASi::PostscriptDocument::_osBody</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="9c160fc430c5855a953ebba33ed67b49"></a><!-- doxytag: member="LASi::PostscriptDocument::_osFooter" ref="9c160fc430c5855a953ebba33ed67b49" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classLASi_1_1oPostscriptStream.html">oPostscriptStream</a> <a class="el" href="classLASi_1_1PostscriptDocument.html#9c160fc430c5855a953ebba33ed67b49">LASi::PostscriptDocument::_osFooter</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="LASi_8h-source.html">LASi.h</a><li><a class="el" href="psDoc_8cpp.html">psDoc.cpp</a></ul>
<hr size="1"><address style="text-align: right;"><small>Generated on Fri Feb 8 17:25:20 2008 for LASi by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.4 </small></address>
</body>
</html>
